﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace KioskDemo.Custom_Controls
{
    class MenuGrid
    {
        //Store a list of panels that make up the page
        private List<MenuPanel> panels = new List<MenuPanel>();

        public MenuGrid()
        {

        }

        public List<MenuPanel> Panels { get { return panels; } }

        //Provide way to add panel
        public void AddPanel(MenuPanel panel)
        {
            //Add to list
            panels.Add(panel);
            UpdateLayout();
        }

        public void UpdateLayout()
        {
            if (panels.Count == 0) return;

            //Get width and height of the control to which this is added (i.e. main window = Parent)
            int width = ((panels[0]).Parent).Width;
            int height = ((panels[0]).Parent).Height;
            //Now work out how to lay them out
            if (panels.Count <= 2)
            {
                //1*2 grid
                for (int i = 0; i < panels.Count; i++)
                {
                    panels[i].Location = new System.Drawing.Point(i % 2 * (width / 2), 0);
                    panels[i].Size = new System.Drawing.Size(width / 2, height);
                }

            }
            else if (panels.Count <= 4)
            {
                //2*2
                for (int i = 0; i < panels.Count; i++)
                {
                    panels[i].Location = new System.Drawing.Point(i % 2 * width / 2, (i / 2) * height / 2);
                    panels[i].Size = new System.Drawing.Size(width / 2, height / 2);
                }
            }
            else if (panels.Count <= 6)
            {
                //3 * 2
                for (int i = 0; i < panels.Count; i++)
                {
                    panels[i].Location = new System.Drawing.Point(i % 3 * width / 3, (i / 3) * height / 2);
                    panels[i].Size = new System.Drawing.Size(width / 3, height / 2);
                }
            }
            //No other combination will be processed or laid out
        }
    }
}
